; Disassembly of [extracted] file "KEYBOARD.DAT"
; Interrupt routine of "Keyboard Driver Program
; ...(1980)(Perkins Engineering)(300 baud).wav"
;
; CPU Type: Z80 for Bally Home Library Computer
;
; Created by Richard C. Degler with dZ80 1.50
;
; on Wednesday, 06 of October 2010 at 05:49 AM
;
; This code assembles with ZMac assembler
; command line: zmac -i -m KEYBOARD.ASM
;

; note: 300-baud tape Bally BASIC program to use Blue Ram Keyboard -
; Scans for keyswitch closure and converts to ASCII based on other
; special keys.  Inserts result into normal Tape Buffer to be read.
;
; ERASE ERASE ERASE ERASE ERASE ERASE ERASE ERASE ERASE ERASE &(192)=0;[no c/r yet]
; [backspace ten times to start of line, set AUTO/mode to RAM, then...]
; A=28416;FOR N=ATO 28630;%(N)=KP;NEXT N;IF KP#85PRINT ;TV=69;TV=82;TV=82;TV=79;TV=82;TV=13[c/r]
; [immediate mode - copy code into !6F00 thru !6FD6]
; [note: uses eXtended memory inside BRB stack area]
;        DB      $F3,$3E,$6F,$ED,$47,$3E,$C2,$D3 <-- [this part is the KEYBOARD.DAT file]
;        DB      $0D,$C3,$33,$21,$CD,$B0,$20,$F3
;        DB      $F5,$D9,$78,$3D,$C3,$CC,$6F,$C5
;        DB      $3E,$3F,$D3,$A2,$01,$00,$3D,$51
;        DB      $78,$3D,$D3,$A0,$DB,$86,$B7,$28
;        DB      $11,$10,$F5,$AF,$D3,$A2,$CB,$71
;        DB      $20,$2D,$5F,$CB,$42,$20,$54,$1C
;        DB      $18,$72,$3E,$38,$90,$F2,$51,$6F
;        DB      $ED,$44,$47,$3E,$80,$07,$10,$FD
;        DB      $B2,$57,$DB,$A0,$E6,$3F,$47,$18
;        DB      $D0,$CB,$71,$20,$07,$DB,$A0,$F6
;        DB      $40,$4F,$18,$CD,$5F,$18,$CC,$CB
;        DB      $42,$20,$28,$B3,$20,$42,$3D,$CB
;        DB      $5A,$28,$02,$3E,$06,$5F,$79,$D6
;        DB      $10,$FE,$60,$30,$41,$FE,$3C,$38
;        DB      $06,$FE,$40,$30,$19,$D6,$10,$CB
;        DB      $4A,$28,$02,$EE,$10,$CB,$62,$28
;        DB      $02,$EE,$40,$C1,$4F,$CB,$52,$C3
;        DB      $18,$21,$C5,$C3,$18,$21,$CB,$52
;        DB      $20,$08,$CB,$4A,$20,$E7,$C6,$20
;        DB      $18,$E3,$CB,$4A,$28,$DF,$18,$F6
;        DB      $3C,$28,$05,$1D,$C1,$C3,$28,$21
;        DB      $CB,$5A,$28,$F8,$18,$B5,$D6,$60
;        DB      $21,$C4,$6F,$85,$6F,$7E,$18,$CB
;        DB      $F6,$20,$0C,$6F,$20,$09,$0A,$0E
;        DB      $0F,$0D,$1B,$1F,$3A,$C2,$4E,$FE
;        DB      $01,$C2,$28,$21,$C3,$17,$6F
; [215 bytes of keyboard handler data (see dis-assembly below)]
; U
; [expects !55 here else print "ERROR[c/r]"
; &(64)=0[c/r]
; [back into immediate mode - keyboard on]
; ??? -> -1
; [not sure why, but it gets backspaced anyway]
; ERASE ERASE ERASE :RETURN ;CLEAR ;CALL28416;&(14)=8;NT=3[c/r]
; [runs machine code, disable LP Interrupts, restore note time]
;

; another note: JAMESCO 610 key LOGICAL layout for BRB keyboard
;
; Had to figure this out from the Keyboard wiring instructions.
; Hopefully it's right, I kept wanting to put it in ASCII order!
; Missing info on "Logic Block" hardware to verify this though.
;
; \ ls     Y-0    Y-1    Y-2    Y-3    Y-4    Y-5    Y-6    Y-7
; ms     ______ ______ ______ ______ ______ ______ ______ ______
;
; X-0  =    0     1 !    2 "    3 #    4 $    5 %    6 &    7 '
;
; X-1  =   8 (    9 )    : *    ; +    , <    - =    . >    / ?
;
; X-2  =   @ `     A      B      C      D      E      F      G
;
; X-3  =    H      I      J      K      L      M      N      O
;
; X-4  =    P      Q      R      S      T      U      V      W
;
; X-5  =    X      Y      Z     [ {    \ |    ] }    ^ ~    B.S.
;
; X-6  =  SPACE   TAB    L.F. User#1 User#2 RETURN   ESC  Delete
;
; X-7  =  BREAK  SHIFT  CAPS. REPEAT  CTRL
;
;
; Unfortunately that means the Keyboard side CONNECTOR Socket is:
;
;       X-1    X-3    X-6    X-5    Y-1    Y-3    Y-7    Y-4
;     ,-------------------------------------------------------.
;    / . 1      2      3      4      5      6      7      8   |
;    |                                                        |
;     )             note: BOTTOM / PIN side view              |
;    |                                                        |
;    |  16     15     14     13     12     11     10      9   |
;    `--------------------------------------------------------'
;       X-2    X-0    X-4    X-7    Y-2    Y-0    Y-5    Y-6
;
; rather random, unless it made making the Keyboard cable easier.
;

        NOLIST

        INCLUDE "HVGLIB.H"      ; HOME VIDEO GAME LIBRARY

; a few defines
CR      EQU     $0D             ; 'GO' key = ASCII 13
RUBOUT  EQU     $1F             ; 'ERASE' = Keycode 31

; Bally BASIC cartridge's routine addresses
L20B0   EQU     $20B0           ; normal 60Hz TBI INTerrupt routine
L20F6   EQU     $20F6           ; BB's normal Lite Pen INTerrupt
L2118   EQU     $2118           ; LPI2 + 2 to bump TAPe INSert pointer and insert C
L2128   EQU     $2128           ; LPI3 to do EXX then LPIEXit
L2133   EQU     $2133           ; TVLLNK to Prepare for tape input

        LIST

        ORG     $6F00

; L6F00: ****** SETUP: called *once* from Basic program ***
        DI
        LD      A,$6F           ; change Interrupt Vector for...
        LD      I,A
        LD      A,$C2           ; ...replacement Vector at L6FC2
        OUT     (INFBK),A
        JP      L2133           ; to BB's TVLLNK (does Prepare for tape input)

; ++++++ Replacement Interrupt routine +++
L6F0C:  CALL    L20B0           ; do Bally Basic's TBIINT (does normal interrupt)
        DI
        PUSH    AF
        EXX
        LD      A,B
        DEC     A
        JP      L6FCC           ; to CHECKIT stub (does read CHMODE and bail if <KBD in> set)

; HANDLEKEYBOARD: back here if <TAPe in> mode on [lines up with BRB1.1 FKBSCAN starting at L3F18:]
L6F17:  PUSH    BC
; ****** FKBSCAN + 9: do Full KeyBoard SCAN as opposed to only a scan of the 'BREAK' and 'ESC' keys. ***
        LD      A,00111111B
        OUT     ($A2),A         ; write $3F to outport 162 to set PORT(A) bits 6 & 7 only as INPUT
        LD      BC,$3D00        ; B = 61 for Key Count, C = 0
        LD      D,C             ; and D = 0 for No Special 'SHIFT'/'CTRL'/'BREAK' keys yet
; *** SCAN1: loop for each Key in B ***
L6F20:  LD      A,B             ; read Key Count
; *** SCAN2: loop for Next Key in A ***
L6F21:  DEC     A               ; scan Keys from 60 down to 0
        OUT     ($A0),A         ; write to outport 160 to write to PORT(A) OUTPUT bits 0 to 5 only
        IN      A,($86)         ; read inport 134 for Port(A) INPUT bit 6 only
        OR      A               ; set flags by KEY DOWN strobe
        JR      Z,L6F3A                 ; (+$11) to PRESSED if bit 6 was LO
; *** SCAN3: to scan Next Key ***
L6F29:  DJNZ    L6F20                   ; (-$0b) loop to SCAN1 until Key Count = 0
; *** SCAN4: done scanning, Reset Port and check BREAK and  ***
L6F2B:  XOR     A
        OUT     ($A2),A         ; out 0 to port 162. This configures PORT(A) as an INPUT device.
        BIT     6,C             ; check for BEEN READ flag
        JR      NZ,L6F5F                ; (+$2d) to FOUND if Been Read bit set
        LD      E,A             ; else Clear for NO Repeat Delay
        BIT     0,D             ; check for BREAK flag
        JR      NZ,L6F8B                ; (+$54) to INSertCHAR if 'BREAK' had been pressed
        INC     E              ; else E = 1 for Short Repeat Delay
        JR      L6FAC                   ; (+$72) to NOINSert

; *** PRESSED: when KEY in A returns DOWN Strobe ***
L6F3A:  LD      A,$38           ; for KEY #56 (happens to be marked as 'BREAK' key)
        SUB     B               ; minus key being scanned when press found
        JP      P,L6F51         ; to REGULAR if Scan Code up to Special keys
        NEG                     ; else underflowed so make POSitive
        LD      B,A             ; loop counter 1 through 5
        LD      A,10000000B     ; $80 for single Bit 7
; *** SPECIAL: to SET BREAK, SHIFT or ConTRoL bit in D and keep scanning ***
L6F45:  RLCA
        DJNZ    L6F45                   ; (-$03) loop to SPECIAL to Rotate Left Circular
        OR      D               ; set Bit 0 for 'BREAK', Bit 1 for 'SHIFT's, Bit 2 for 'CAPSLOCK', ...
        LD      D,A             ; ... Bit 3 for 'REPEAT', or Bit 4 for 'CTRL' Key marked
        IN      A,($A0)         ; read inport 160 for last PORT(A) OUTPUT value
        AND     00111111B       ; mask with $3F for current SCAN KEY only
        LD      B,A
        JR      L6F21                   ; (-$30) loop to SCAN2 for Next key

; *** REGULAR: when Key Pressed was Not a Special key ***
L6F51:  BIT     6,C             ; check for BEEN READ before ?
        JR      NZ,L6F5C                ; (+$07) to BEFORE if Not first key read
        IN      A,($A0)         ; else read inport 160 for last PORT(A) OUTPUT value
        OR      $40             ; set Bit 6 for Been Read once
        LD      C,A             ; save Scan Key and flag
        JR      L6F29                   ; (-$33) to SCAN3 to SCAN another Key

; *** BEFORE: if another Key has Been Read BEFORE stub ***
L6F5C:  LD      E,A             ; save new Scan Key if Second key pressed
        JR      L6F2B                   ; (-$34) to SCAN4 to Reset Port(A) then to FOUND

; *** FOUND: on Key FOUND (if Key has BEEN READ) with 0 in A subroutine***
L6F5F:  BIT     0,D             ; check for 'BREAK' key
        JR      NZ,L6F8B                ; (+$28) to INSertCHAR if 'BREAK' had been pressed
        OR      E               ; mask 0 with SECOND Scan Key or REPEAT Delay
        JR      NZ,L6FA8                ; (+$42) to CHANGED if E has changed
        DEC     A               ; preset to $FF for No Repeat flag
        BIT     3,D             ; check for REPEAT key
        JR      Z,L6F6D                 ; (+$02) skip to MAKEASCII if REPEAT Not pressed
; *** SETREPEAT: to set REPEAT rate to Max Delay ***
L6F6B:  LD      A,$06
; *** MAKEASCII: to MAKE ASCII from Key pressed (0 through 55) + 64 ($40) in C ***
L6F6D:  LD      E,A             ; save $FF for No Repeat or $06 for Repeat delay
        LD      A,C             ; Key Scan with BEEN READ flag
        SUB     $10             ; minus 16 for Key Scan (0 through 55) + 48 ($30)
        CP      $60             ; is greater than or equal 96 ? (original Key Scan was 48 through 55)
        JR      NC,L6FB6                ; (+$41) to CONVERT to Control if marked 'SPACE' and up
        CP      $3C             ; is less than 60 ? (original Key Scan was below 12, marked 'COMMA')
        JR      C,L6F7F                 ; (+$06) skip to NUMBERS if 'Number key' or ':' or ';'
        CP      $40             ; is greater than or equal 64 ? (original Key Scan was 16 through 47)
        JR      NC,L6F96                ; (+$19) to SHIFT if 'AT' or 'A' to 'Z' through 'BackSpace'
        SUB     $10             ; else minus 16 for (was Keys 12 through 15) + 32 ($20) if ',' thru '/'
; *** NUMBERS: skip here if '0' through '9' or 'COLON' or 'SEMI-COLON' plus some fall-throughs ***
L6F7F:  BIT     1,D             ; check for Left or Right SHIFT key [Top row NOT affected by CapsLock]
        JR      Z,L6F85                 ; (+$02) skip to CONTROL if Not SHIFTed
        XOR     00010000B       ; 16 ($10) to TOGGLE bit 4 to SHIFT down Numbers or up to '<' thru '?'
; *** CONTROL: check if CTRL is pressed (already ASCII 32 to 127, so ADD or SUB 64 for ConTRoL Key) ***
L6F85:  BIT     4,D             ; check for CTRL flag
        JR      Z,L6F8B                 ; (+$02) skip to INSertCHAR if CTRL key is Not pressed
        XOR     01000000B       ; 64 ($40) to TOGGLE bit 6 for ConTRoL byte
; *** INSertCHAR: bump TAPINS and INSert CHARacter  *** [NOT BRB1.1's LOCKMRthenKEYBD1] ***
L6F8B:  POP     BC
        LD      C,A             ; save ASCII code for key
        BIT     2,D             ; check for CAPS LOCK key [result NOT used ??]
        JP      L2118           ; to BB's LPI2 + 2 (does bump TAPe INSert pointer and insert C)
; ?? L6F92: [not used ??] ****** [not BRB's LOCKMR to LOCK out Magic Register by E] ***
        PUSH    BC
        JP      L2118           ; to BB's LPI2 + 2 to bump TAPe INSert pointer

; *** SHIFT: to add SHIFT value if ASCII 64 ($40) through 95 ($5F) Unless SHIFTed stub ***
L6F96:  BIT     2,D             ; check for CAPS LOCK key
        JR      NZ,L6FA2                ; (+$08) to CAPSLOCK if pressed
        BIT     1,D             ; check for Left or Right SHIFT key
        JR      NZ,L6F85                ; (-$19) to CONTROL if either SHIFT was pressed
; *** UNSHIFT: if Neither SHIFT key or CAPSLOCK (or Both) to ASCII 96 ($60) through 127 ($7F) ***
L6F9E:  ADD     A,$20           ; add 32 to ASCII value for Lower Case or SHIFTED non-Number Keys
        JR      L6F85                   ; (-$1d) to CONTROL

; *** CAPSLOCK: Handle CAPS LOCK stub ***
L6FA2:  BIT     1,D             ; check for Left or Right SHIFT key
        JR      Z,L6F85                 ; (-$21) to CONTROL if Neither SHIFT pressed
        JR      L6F9E                   ; (-$0a) else to UNSHIFT if canceled out

; *** CHANGED: if E had changed (A is copy of E) stub ***
L6FA8:  INC     A               ; was NO REPEAT flaged with $FF ?
        JR      Z,L6FB0                 ; (+$05) to NOREPEAT if No Repeat
        DEC     E               ; else count down Repeat Count
; *** NOINSert: then RETurn [not BRB's JPtoLOCKMR by E] ***
L6FAC:  POP     BC
        JP      L2128           ; to BB's LPI3 (does EXX then LPIEXit)

; *** NOREPEAT: to check for REPEAT if Off or Counted Down stub ***
L6FB0:  BIT     3,D             ; check for REPEAT key still down ?
        JR      Z,L6FAC                 ; (-$08) to NOINSert if REPEAT Not pressed
        JR      L6F6B                   ; (-$4b) else to SETREPEAT rate for a full delay

; *** CONVERT: on Keys 'SPACE', 'TAB', 'L.F.', 'User#1', 'User#2', 'RETURN', 'ESC', or 'Delete' [new for BRB]
L6FB6:  SUB     $60             ; make 0 to 7
        LD      HL,L6FC4        ; point at CTRLCON for CONvert to ASCII ConTRoL
        ADD     A,L
        LD      L,A
        LD      A,(HL)          ; read replacement entry
        JR      L6F8B                   ; (-$35) to INSertCHAR

; ++++++ Interrupt Vectors Block +++
; +++ L6FC0: (at L6FC2 & $FFF8) Lite Pen [not BRB's POPHLthenADDKEYB stub ??] +++
        DW      L20F6           ; Bally Basic's normal LPINT

; +++ L6FC2: Screen Interrupt Vector +++
        DW      L6F0C           ; replacement Interrupt Routine

; ********* CTRLCON: ConTRoL Key CONversion Table used by CONVERT routine [new for BRB] ***
L6FC4:
        DB      ' '             ; 32 ($20) ascii 'SPACE'
        DB      $09             ; ascii [HT]
        DB      $0A             ; ascii [LF]
        DB      $0E             ; ascii [SO]
        DB      $0F             ; ascii [SI]
        DB      CR              ; 13 ($0D) ascii 'Carriage Return'
        DB      $1B             ; ascii [ESC]
        DB      RUBOUT          ; 31 ($1F) ascii [US] for 'BackSpace'

; *** CHECKIT: to read CHMODE [stub NOT found in BRB] ***
L6FCC:  LD      A,($4EC2)       ; read CHMODE (300 baud tape status indicator)
        CP      $01             ; is it 1=TAP in, VID out ?
        JP      NZ,L2128        ; to BB's LPI3 (does EXX then LPIEXit)
        JP      L6F17           ; to HANDLEKEYBOARD (handle keyboard as TAPe input)

; *** End of Code flag ***
;        DB      01010101B       ; 'U' checked for by Basic program

